#include<windows.h>
#include<mmsystem.h>							//   
#include<C:\DXSDK\Include\d3d9.h>		//   DirectX9
#include<C:\DXSDK\Include\d3dx9.h>		// 

#pragma comment(lib, "C:\\DXSDK\\Lib\\d3d9.lib")		//  DirectX9
#pragma comment(lib, "C:\\DXSDK\\Lib\\d3dx9.lib")		//  
#pragma comment(lib, "winmm.lib")

#include "init3d.h"
#include "render.h"

LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM iParam)
{
	switch(message)             //  
	{
	case WM_DESTROY:
		Destroy3D();    //   
		PostQuitMessage(0);
		break;
	case WM_CHAR:			//  ,   
		PostQuitMessage(0);
		break;
	case WM_SETCURSOR:		//     
		SetCursor(NULL);
		break;
	}
	return(DefWindowProc(hWnd, message, wParam, iParam));
}//-----------------------------------------------------------------------------------
bool WindowInit(HINSTANCE hThisInst, int nCmdShow)
{
WNDCLASS wcl;				// 
	wcl.hInstance=hThisInst;
	wcl.lpszClassName="DirectX 9";
	wcl.lpfnWndProc=WindowProc;
	wcl.style=0;
	wcl.hIcon=LoadIcon(hThisInst, IDC_ICON);
	wcl.hCursor=LoadCursor(hThisInst, IDC_ARROW);
	wcl.lpszMenuName=NULL;
	wcl.cbClsExtra=0;
	wcl.cbWndExtra=0;
	wcl.hbrBackground=(HBRUSH)GetStockObject(BLACK_BRUSH);
	RegisterClass(&wcl);
	hWnd=CreateWindowEx(WS_EX_TOPMOST, "DirectX 9", "DirectX 9", WS_POPUP, 0, 0, 800, 600, NULL, NULL, hThisInst, NULL);
	if(!hWnd)
		return(false);	//,   
	return(true);		// 
}//-----------------------------------------------------------------------------------
bool AppInit(HINSTANCE hThisInst, int nCmdShow)
{
    if(!WindowInit(hThisInst, nCmdShow))
        return(false);
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
    if(!InitDirectX())		//  DirectX
        return(false);		//  ,  
    return(true);
}//-----------------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hThisInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
MSG msg;
	if(!AppInit(hThisInst, nCmdShow))
		return(false);
	ZeroMemory(&msg, sizeof(msg));
	while(msg.message!=WM_QUIT)
	{
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}else
			RenderScene();
	}
	return(0);
}//-----------------------------------------------------------------------------------